"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.nodeTypesController = void 0;
const express_1 = __importDefault(require("express"));
const promises_1 = require("fs/promises");
const lodash_get_1 = __importDefault(require("lodash.get"));
const config_1 = __importDefault(require("../config"));
const NodeTypes_1 = require("../NodeTypes");
const ResponseHelper = __importStar(require("../ResponseHelper"));
const TranslationHelpers_1 = require("../TranslationHelpers");
const typedi_1 = require("typedi");
exports.nodeTypesController = express_1.default.Router();
exports.nodeTypesController.post('/', ResponseHelper.send(async (req) => {
    const nodeInfos = (0, lodash_get_1.default)(req, 'body.nodeInfos', []);
    const defaultLocale = config_1.default.getEnv('defaultLocale');
    if (defaultLocale === 'en') {
        return nodeInfos.reduce((acc, { name, version }) => {
            const { description } = typedi_1.Container.get(NodeTypes_1.NodeTypes).getByNameAndVersion(name, version);
            acc.push(description);
            return acc;
        }, []);
    }
    async function populateTranslation(name, version, nodeTypes) {
        const { description, sourcePath } = typedi_1.Container.get(NodeTypes_1.NodeTypes).getWithSourcePath(name, version);
        const translationPath = await (0, TranslationHelpers_1.getNodeTranslationPath)({
            nodeSourcePath: sourcePath,
            longNodeType: description.name,
            locale: defaultLocale,
        });
        try {
            const translation = await (0, promises_1.readFile)(translationPath, 'utf8');
            description.translation = JSON.parse(translation);
        }
        catch (error) {
        }
        nodeTypes.push(description);
    }
    const nodeTypes = [];
    const promises = nodeInfos.map(async ({ name, version }) => populateTranslation(name, version, nodeTypes));
    await Promise.all(promises);
    return nodeTypes;
}));
//# sourceMappingURL=nodeTypes.api.js.map