"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Delete = exports.Patch = exports.Post = exports.Get = void 0;
const constants_1 = require("./constants");
const RouteFactory = (method) => (path) => (target, handlerName) => {
    var _a;
    const controllerClass = target.constructor;
    const routes = ((_a = Reflect.getMetadata(constants_1.CONTROLLER_ROUTES, controllerClass)) !== null && _a !== void 0 ? _a : []);
    routes.push({ method, path, handlerName: String(handlerName) });
    Reflect.defineMetadata(constants_1.CONTROLLER_ROUTES, routes, controllerClass);
};
exports.Get = RouteFactory('get');
exports.Post = RouteFactory('post');
exports.Patch = RouteFactory('patch');
exports.Delete = RouteFactory('delete');
//# sourceMappingURL=Route.js.map